/*
 * Read %CR8 from userspace (CPL=3) and verify that it triggers a #GP.
 * sudo ./a.out
 * pid 75492 comm a.out: signal 10 err 0 code 3 type 9
 *
 * The 'type' field above should be '9' corresponding to T_PROTFLT
 */

#include <sys/param.h>
#include <sys/sysctl.h>

#include <stdio.h>
#include <stdlib.h>

int
main(void)
{
	int error, val;
	u_long	data;

	val = 1;
	error = sysctlbyname("machdep.uprintf_signal", NULL, NULL, &val,
	    sizeof(int));
	if (error) {
		perror("sysctlbyname(machdep.uprintf_signal)");
		exit(1);
	}

	__asm __volatile("movq %%cr8,%0" : "=r" (data));
	printf("cr8 = %#lx\n", data);
}
